### Join my [Discord Server](https://discord.gg/c74mqPuQaV) for support or updates on future stuff

# What is this mod?
Well im glad you asked! This mod works as a mod.io subscription integration mod, a Fusion extension, and a mod manager! Currently, the mod REQUIRES Fusion to be installed for it to function. (This is intentional)

![](https://cdn.discordapp.com/attachments/1034590677234884699/1107452928932990976/ezgif.com-video-to-gif_4.gif)

# ```Custom UI Demonstration VIDEO```
[![IMAGE ALT TEXT](http://img.youtube.com/vi/H4qOpaM34i0/0.jpg)](http://www.youtube.com/watch?v=H4qOpaM34i0 "Mod Io Mod Networker UI Demonstration")
# Features
- Mod.io Subscription Auto Downloading (On Game Boot)
- Auto Updating of Subscribed Mods
- Ability to uninstall mods
- Ability to download the Hosts Subscribed mods in a Fusion lobby
- Realtime modloading, instantly use mods that you have downloaded midgame without a game restart!
- Automatic avatar downloading.
- Automatic spawnable downloading.
- Automatic level downloading.
- Temporary lobby mods.
- Custom UI
- Repository integration (Download mods from anyone)
- Quest Support
# How do I use this?
## ```Installation```
Drag the ModioModNetworker dll from "Mods" into your Mods folder.
### ```Video Guide```
[![IMAGE ALT TEXT](http://img.youtube.com/vi/gH6pMVPOJco/0.jpg)](http://www.youtube.com/watch?v=gH6pMVPOJco "Mod Io Video Tutorial")
## ```How to link your mod.io account (IMPORTANT, PLEASE READ FULLY)```
### When you first launch the game with this mod, a folder will be created in your game directory labeled "ModioModNetworker". (Your game directory is the directory containing your Bonelab application) <br>
### Inside of this folder, there will be a txt file labeled auth.txt. <br>
### This txt file contains the remaining instructions to finish linking your mod.io account to the mod. Don't worry, its a fairly simple process. 
### Restart your game after finishing the instructions.
### If you finished all the steps in the txt and it still does not function, see the "COMMON ISSUES" section of this page.
## ```I've set it all up now, whats next?```
Well, say goodbye to manually downloading your mods and handling all that zip and drag nonsense. You can now easily install your mods directly from mod.io by pressing subscribe on them! <br> <br>
Unsubscribed mods that you have installed will not auto-update! Keep that in mind. So if you want a mod to auto update, make sure to subscribe to it. <br> <br>
A small annoyance with the mod is the fact that it will reinstall mods that you subscribed to even if you technically already have them. This will only happen once. This is because the mod has no prior knowledge of mods installed without it. There will not be duplicates, your old mods will get overwritten.
## ```How do I download mods from other people?```
Just join a server! As of 2.0.0, you can just join anyones server and automatically download mods being used! This only applies if you have the "Use Repository" setting enabled. It is enabled by default. <br>

If you do not have the "Use Repository" setting enabled, you have to join a networker server to gain autodownload benefits. The mods also have to be tracked by networker to get shared to everyone else. (Subscribed/Installed via networker)
# COMMON ISSUES
## ```I followed the instructions in auth.txt and it still isnt working, whats wrong?```
### Things that could have went wrong: <br>
### - You pasted in your KEY and not your TOKEN. They are two different things, paste your TOKEN. <br>
### - You have extra characters or missing characters in your auth.txt. Make sure you keep the AuthToken= section of the auth.txt.
#
#### If you double checked all these potential problems and the mod still does not function, you can contact me directly on Discord at notnotnotswipez#0001 and I will try to assist you. Or join my Discord server linked at the top of the page.
# Changelog
# 2.2.3
- Fixed subscribed mods displaying correctly.
- Fixed mods not properly deleting existing objects under the mod reload condition.
# 2.2.2
- Updated to support Fusion 1.6.3
# 2.2.1
- Thunderstore change
# 2.2.0
- Optimized logic
- Updated to support Fusion 1.6.0
# 2.1.1
- Fixed subscribe button not functioning
- Fixed items not deleting properly when a mod is uninstalled
- Fixed mods not deleting in the Quest filesystem
# 2.1.0
- Added Quest Support
- Added new console error which warns you when the auth token put into auth.txt is less than the expected character count
- Switched to UnityWebRequests for downloading
- Added patch to prevent mods which shared the same id being downloaded more than once in a singular lobby session
- Fixed repo identification not displaying the avatar download progress bar UI
- Fixed "Host Mods" section of UI not being scrollable
- Changed logic of "Uninstall All Unsubscribed" button to only uninstall fully networker tracked mods.
- Added patch to prevent subscribed mods from being redownloaded via requests in sessions
- Changed wording slightly on autogenerated auth.txt file to reduce confusion
- Fixed bug where repo identification may have downloaded a mature mod even though your preferences prevented this
# 2.0.0
- Add repo support (Download spawnables/avatars/levels from people who do not have networker).
- Removed game stalling upon download.
- Removed game stalling when unsubscribing/subscribing.
- Switch to httpwebrequest for api calls (Less wasteful).
- Added custom menu.
- Added trending tab.
- Added settings tab.
- Added file management tab.
- Added ingame blacklist management.
- Added search feature for trending tab.
- Improved logic with thread management (Performance).
- Added button to Fusion lobby panel to download the level if you don't have it.
- Added more information to modinfo.json.
- Added tracking support for non-networker tracked mods.
# 1.5.0
- Added blacklist.txt (Generated next to auth.txt).
- Fixed bug that could occur when a mod had a singular digit version, causing errors on boot.
- Fixed host mods menu erroring when used.
- Added autoupdater plugin.
- Added data to lobbies which are running this mod, you can see on the lobby panel if a mod is running networker.
# 1.4.1
- Fixed compatibility for Fusion 1.4.0+
- Patched issue that could allow subscribed mods to be redownloaded in a public lobby under certain conditions.
- Patched issue where the mod would attempt to download subscribed mods that are no longer available on mod.io.
- Fixed potential issue that could occur when a mod has no official version set on mod.io, making it repeat the download.
# 1.4.0
- Added UI to players when you are downloading an avatar of theirs.
- Added functionality to auto download spawnables (Toggleable)
- Added functionality to auto download levels (Toggleable, you also have to already be in the lobby)
- Added temporary mods option, if enabled, all mods that were auto downloaded (Levels, Avatars, Spawnables) will get deleted and removed when you exit the lobby.
- Fixed small bug that prevented the "Max MB download" setting from updating in the menu.
- Improved backend queue.
- Added "Cancel Download" button to the menu when a mod is being installed.
# 1.3.0
- Added auto avatar downloading. (Max file size and NSFW mod downloading are configurable). This feature is also able to be disabled but is enabled by default.
- Added "Installed" section to the Management section, includes a "Delete all unsubscribed installed mods" button.
- Improved modinfo backend system.
# 1.2.0
- Fixed bug that could prevent mods from being sent to people in a Fusion lobby under specific circumstances.
# 1.1.0
- Fixed subscription limit for 100+ subscribed mods.
- Fixed random mods not downloading.
- Fixed game crash on some downloaded mods.
- Added support for multipackaged mods. (Mods that are a collection of other mods).
- Fixed errored downloads on large mods.
- Fixed errored downloads on large mod queue downloads.
- Massively optimized amount of API calls to prevent ratelimiting.
- Fixed long freezing on menu refreshes when large mod counts were present.
- Improved menu functionality. (Pages added)
- Added "Management" section where you can install all of the Host's mods at once.